--function aus GuilsMailer

--[[

    GuildMailer

    Written by Cragganmore

    GuildMailer adds a mailing list functionality to the in-game mail system.
    
    In the mail frame, a button next to the "To:" field will open your mailing
    list frame.  Here, you can define, edit, and select mailing lists of one
    or more character names.  To send to a mailing list, just enter the name
    of the mailing list in the "To:" field in place of a normal character name.
    Guildmailer will send your message to each character on the mailing list.
    
    Guildmailer does not support attachments.
    
    
    
    Added import button wich allows you to import entire guild.
    -Beider
    
  ]]--

-- Global constants
GUILDMAILER_DEBUG = false;

-- Saved variables
GUILDMAILER_CONFIG = { };
GUILDMAILER_CONFIG.ENABLED = 0;
GUILDMAILER_CONFIG.TIMEOUT = 20;
GUILDMAILER_CONFIG.SELECTED_MAILINGLIST = "";
GUILDMAILER_CONFIG.MAILINGLISTS = { };

-- Local variables (Obtained from http://www.cosmosui.org/forums/viewtopic.php?t=5525)
local GUILDTAB_ID = 3;
local GUILDTAB_SHOWOFFLINE = 1;

local previousFriendsFrameVisible = nil;
local previousSelectedTab = nil;
local previousShowOffline = nil;

-- Local variables for Shopping
local mailboxopen = 0;
local basketempty = 1;
--local basketempty = 1;
local orderwaiting = 0;
local alert = 0;


-----------------------------------------------------------------------------------
--
-- Debug function to view any lua object as text
--
-----------------------------------------------------------------------------------
function asText(obj)

    visitRef = {}
    visitRef.n = 0

    asTxRecur = function(obj, asIndex)
        if type(obj) == "table" then
            if visitRef[obj] then
                return "@"..visitRef[obj]
            end
            visitRef.n = visitRef.n +1
            visitRef[obj] = visitRef.n

            local begBrac, endBrac
            if asIndex then
                begBrac, endBrac = "[{", "}]"
            else
                begBrac, endBrac = "{", "}"
            end
            local t = begBrac
            local k, v = nil, nil
            repeat
                k, v = next(obj, k)
                if k ~= nil then
                    if t > begBrac then
                        t = t..", "
                    end
                    t = t..asTxRecur(k, 1).."="..asTxRecur(v)
                end
            until k == nil
            return t..endBrac
        else
            if asIndex then
                -- we're on the left side of an "="
                if type(obj) == "string" then
                    return obj
                else
                    return "["..obj.."]"
                end
            else
                -- we're on the right side of an "="
                if type(obj) == "string" then
                    return '"'..obj..'"'
                else
                    return tostring(obj)
                end
            end
        end
    end -- asTxRecur

    return asTxRecur(obj)
end -- asText


-----------------------------------------------------------------------------------
--
-- Checks for events 
--
-----------------------------------------------------------------------------------
function GuildMailer_OnEvent(event)
    if (event == "MAIL_SEND_SUCCESS" and orderwaiting == 0) then
        GuildMailerDebug("GuildMailer_OnEvent: Got MAIL_SEND_SUCCESS!", 0, 1, 0);
        if (GuildMailer_SendingMail) then
            Print(SHOPPING_MESSAGE_SEND_OK..GuildMailer_MailQueue.Subject..SHOPPING_TIMEOUTMESSAGESEND2..GuildMailer_LastAttempedRecipient.."...", 1.0, 1.0, 0.5);
            GuildMailer_TimeLastMailSent = GetTime();       
        end
        GuildMailer_ReadyToSendNextMessage = true;
		mailboxopen = 1;
--		Print("Mailbox auf!");
    elseif (event == "MAIL_SEND_SUCCESS" and orderwaiting == 1) then
		mailboxopen = 1;
		sendShoppingCart();
    elseif (event == "MAIL_CLOSED") then
        GuildMailerDebug("GuildMailer_OnEvent: Got MAIL_CLOSED!");
        GuildMailerListMakerFrame:Hide();
        GuildMailerNewListPopup:Hide(); 
		mailboxopen = 0;
--		Print("Mailbox zu!");
	elseif (event == "VARIABLES_LOADED") then
		checkOrders();
		Shopping_OnLoad();	
		if (alert == 1) then
			UIFrameFlash(ShoppingToggleButton, 0.2, 0.2, 30, true, 0.3, 0.3);
		end
    end
end


---------------------------------------------------------------------------------
--
-- Register with Cosmos UI
-- 
---------------------------------------------------------------------------------
function GuildMailer_RegisterCosmos()

    --
    -- Add an entry to the Cosmos configuration menu
    --
    if (Cosmos_RegisterConfiguration) then
        Cosmos_RegisterConfiguration(
            "COS_GUILDMAILER",
            "SECTION",
            GUILDMAILER_CONFIG_HEADER,
            GUILDMAILER_CONFIG_HEADER_INFO
        );
        Cosmos_RegisterConfiguration(
            "COS_GUILDMAILER_HEADER",
            "SEPARATOR",
            GUILDMAILER_CONFIG_HEADER,
            GUILDMAILER_CONFIG_HEADER_INFO
        );
        Cosmos_RegisterConfiguration(
            "COS_GUILDMAILER_ENABLED",
            "CHECKBOX",
            GUILDMAILER_CONFIG_ENABLED,
            GUILDMAILER_CONFIG_ENABLED_INFO,
            GuildMailer_Toggle,
            GUILDMAILER_CONFIG.ENABLED
        );
        
        -- register our chat commands
        local GuildMailerCommands = {"/guildmailer","/gm"};
        Cosmos_RegisterChatCommand (
            "GUILDMAILER_COMMANDS", -- Some Unique Group ID
            GuildMailerCommands, -- The Commands
            GuildMailer_ChatCommandHandler,
            "" -- Description String
        );

    else
        --SlashCmdList["GUILDMAILER_SLASHENABLE"] = GuildMailer_ChatCommandHandler;
        --SLASH_GUILDMAILER_SLASHENABLE1 = "/guildmailer";
        --SLASH_GUILDMAILER_SLASHENABLE2 = "/gm";
        SlashCmdList["GUILDMAILER_SLASHENABLE"] = Shopping_ChatCommandHandler;
		SLASH_GUILDMAILER_SLASHENABLE1 = "/shopping";
		SLASH_GUILDMAILER_SLASHENABLE2 = "/sh";
    end

    -- make sure we have the Print() function
    if (not Print) then
        function Print(msg, r, g, b, frame) 
            if (not r) then r = 1.0; end
            if (not g) then g = 1.0; end
            if (not b) then b = 1.0; end
            if ( frame ) then 
                frame:AddMessage(msg,r,g,b);
            else
                if ( DEFAULT_CHAT_FRAME ) then 
                    DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
                end
            end
        end
    end

end


---------------------------------------------------------------------------------
--
-- Break a chat command into its command and variable parts (i.e. "debug on"
-- breaks into command = "debug" and variable = "on"
-- 
---------------------------------------------------------------------------------
function GuildMailer_ParseCommand(msg)
    firstSpace = string.find(msg, " ", 1, true);
    if (firstSpace) then
        local command = string.sub(msg, 1, firstSpace - 1);
        local var  = string.sub(msg, firstSpace + 1);
        return command, var
    else
        return msg, nil;
    end
end



---------------------------------------------------------------------------------
--
-- A simple chat command handler, right now just used for debugging purposes
-- 
---------------------------------------------------------------------------------
function GuildMailer_ChatCommandHandler(msg)
    local command, var = GuildMailer_ParseCommand(msg);
    if ((not command) and msg) then
        command = msg;
    end
    if (command) then
        command = string.lower(command);
        if (command == "debug") then
            GuildMailer_ToggleDebug();
        elseif (command == "timeout") then
            GuildMailer_SetTimeout(var);
        elseif (command == "help") then
            GuildMailer_ShowHelp();
        elseif (command == "list") then
            GuildMailer_ShowListMaker();
		elseif (command == "show") then
			Shopping_Frame:Show();
        end
    end
end

---------------------------------------------------------------------------------
--
-- Shopping Command handler
-- 
---------------------------------------------------------------------------------
function Shopping_ChatCommandHandler(msg)
    local command, var = GuildMailer_ParseCommand(msg);
    --if ((not command) and msg) then
    --    command = msg;
    --end
    if (command) then
        command = string.lower(command);
        if (command == "help") then
            Shopping_ShowHelp();
		elseif (command == "show") then
			Shopping_Frame:Show();
		elseif (command == "disable") then
			GUILDMAILER_CONFIG.ENABLED = false;
			Print(SHOPPING_ADDON_DISABLED_TEXT);
		elseif (command == "enable") then
			GUILDMAILER_CONFIG.ENABLED = true;
			Print(SHOPPING_ADDON_ENABLED_TEXT);
			Shopping_OnLoad();
		elseif (command == "") then
			Shopping_ShowUsage();
        end
	end
end

---------------------------------------------------------------------------------
--
-- Show usage for Shopping
-- 
---------------------------------------------------------------------------------
function Shopping_ShowUsage()
	Print(SHOPPING_SHOWUSAGE_MESSAGE, 1.0, 1.0, 0.5);
end

---------------------------------------------------------------------------------
--
-- Show the help msg for Shopping
-- 
---------------------------------------------------------------------------------
function Shopping_ShowHelp()
    Print(SHOPPING_SHOWHELP_MESSAGE, 1.0, 1.0, 0.5);
end



---------------------------------------------------------------------------------
--
-- Show the help msg for guildmailer
-- 
---------------------------------------------------------------------------------
function GuildMailer_ShowHelp()
    Print("GuildMailer: GuildMailer adds a button to the Send Mail screen between the To: and Postage: areas.  This button opens a window where you may create and edit mailing lists.  To send a message to an entire mailing list, enter the name of the mailing list in the To: field.  Due to lag, GuildMailer may time out while trying to send a message.  You can adjust the timeout period in seconds using the \"/guildmailer timeout [1-60]\" command.   QUEUE ADDED!!!  \"/list\" to show mailing lists!", 1.0, 1.0, 0.5);
end


---------------------------------------------------------------------------------
--
-- Set the timeout for sending mail
-- 
---------------------------------------------------------------------------------
function GuildMailer_SetTimeout(theSecs)
    if (theSecs == nil or tonumber(theSecs) == nil) then
        Print("GuildMailer: Usage: /guildmailer timeout [1-60]", 1.0, 1.0, 0.5);
        return
    end

    theSeconds = tonumber(theSecs);
    if ((theSeconds > 0) and (theSeconds < 60)) then
        GUILDMAILER_CONFIG.TIMEOUT = theSeconds;
        Print("GuildMailer: Mail timeout set to "..theSeconds.." seconds.", 1.0, 1.0, 0.5);
    else
        Print("GuildMailer: Usage: /guildmailer timeout [1-60]", 1.0, 1.0, 0.5);
    end
end


-----------------------------------------------------------------------------------
--
-- Handle the loading stuff when the plugin first loads
--
-----------------------------------------------------------------------------------
function GuildMailer_OnLoad()   
	
    this:RegisterEvent("MAIL_FAILED");
    this:RegisterEvent("MAIL_CLOSED");
    this:RegisterEvent("MAIL_SEND_SUCCESS");
	this:RegisterEvent("VARIABLES_LOADED");
    
    -- the structure to store the outgoing mail queue
    GuildMailer_MailQueue = { };
    GuildMailer_MailQueue.Body = "";
    GuildMailer_MailQueue.Subject = "";
    GuildMailer_MailQueue.Recipients = { };
        
    GuildMailer_SendingMail = false;
    
    -- register with Cosmos
    GuildMailer_RegisterCosmos();

    -- hook the sendMail function so we can take it over to do our bidding
    GuildMailer_HookSendMail(true); 
end



-----------------------------------------------------------------------------------
--
-- Workaround functions to handle a problem where the money field of a tooltip
-- will get hidden whenever tooltips are invoked.
-- 
-- Code by Telo.  From his post:
--   "Whenever a tooltip is set, the game sends a CLEAR_TOOLTIP event, which causes GameTooltip_OnEvent to call 
--   GameTooltip_ClearMoney, hiding the money frame for GameTooltip. There doesn't appear to be any identifying 
--   information sent with the CLEAR_TOOLTIP event that would allow GameTooltip_OnEvent to discriminate between 
--   its tooltip and others, so simply hooking this function doesn't appear to help. I've worked around the 
--   issue for my code by using something similar to the following code wherever I use a hidden tooltip."
--   (http://forums.worldofwarcraft.com/thread.aspx?fn=wow-interface-customization&t=16768&tmp=1#post16768)
--
-----------------------------------------------------------------------------------
local lOriginal_GameTooltip_ClearMoney;
local function GuildMailer_MoneyToggle()
    if( lOriginal_GameTooltip_ClearMoney ) then
        GameTooltip_ClearMoney = lOriginal_GameTooltip_ClearMoney;
        lOriginal_GameTooltip_ClearMoney = nil;
    else
        lOriginal_GameTooltip_ClearMoney = GameTooltip_ClearMoney;
        GameTooltip_ClearMoney = GuildMailer_GameTooltip_ClearMoney;
    end
end
function GuildMailer_GameTooltip_ClearMoney()
    -- Intentionally empty; don't clear money while we use hidden tooltips
end


-----------------------------------------------------------------------------------
--
-- Update
--
-----------------------------------------------------------------------------------
function GuildMailer_OnUpdate()

    if (GuildMailer_SendingMail) then
        if (table.getn(GuildMailer_MailQueue.Recipients) > 0) then
            if (GuildMailer_ReadyToSendNextMessage) then
                GuildMailer_MailQueueFrameCounter = math.mod(GuildMailer_MailQueueFrameCounter + 1, 30);
                if (GuildMailer_MailQueueFrameCounter == 0) then
                    Shopping_SendNextMessage();
                    --GuildMailer_SendNextMessage();					
                end
            elseif (GetTime() - GuildMailer_TimeLastMailSent > GUILDMAILER_CONFIG.TIMEOUT) then
                GuildMailer_TimeOutMessageSend();
            end
        elseif (GuildMailer_ReadyToSendNextMessage) then
            GuildMailer_SendingMail = false;
            Print(SHOPPING_ONUPDATE_MESSAGE1..GuildMailer_MailQueue.Subject..".\"", 1.0, 1.0, 0.5);
        end
    end
end




---------------------------------------------------------------------------------
--
-- Handle when a message times out trying to send
-- 
---------------------------------------------------------------------------------
function GuildMailer_TimeOutMessageSend()
    Print(SHOPPING_TIMEOUTMESSAGESEND1..GuildMailer_MailQueue.Subject..SHOPPING_TIMEOUTMESSAGESEND2..GuildMailer_LastAttempedRecipient..SHOPPING_TIMEOUTMESSAGESEND3, 1.0, 0.0, 0.0);
    Shopping_SendNextMessage();
end



-----------------------------------------------------------------------------------
--
-- Send the next message in the outgoing queue
--
-----------------------------------------------------------------------------------
function GuildMailer_SendNextMessage()
    GuildMailer_ReadyToSendNextMessage = false;
    GuildMailer_LastAttempedRecipient = GuildMailer_MailQueue.Recipients[1];
    table.remove(GuildMailer_MailQueue.Recipients, 1);
    SendMail(GuildMailer_LastAttempedRecipient, GuildMailer_MailQueue.Subject, GuildMailer_MailQueue.Body);
end



-----------------------------------------------------------------------------------
--
-- Show the mailing list selection window
--
-----------------------------------------------------------------------------------
function GuildMailer_ShowListMaker()
    GuildMailerDebug("GuildMailer_ShowListMaker!");
    ShowUIPanel(GuildMailerListMakerFrame);
    UIDropDownMenu_SetSelectedValue(GuildMailerListMakerFrameDropDown, GUILDMAILER_CONFIG.SELECTED_MAILINGLIST);
    UIDropDownMenu_SetText(GUILDMAILER_CONFIG.SELECTED_MAILINGLIST, GuildMailerListMakerFrameDropDown);
    GuildMailer_ListMakerEditBox_Init();
end


-----------------------------------------------------------------------------------
--
-- Show the popup window to name a new mailing list
--
-----------------------------------------------------------------------------------
function GuildMailer_ShowNewListPopup()
    GuildMailerDebug("GuildMailer_ShowNewListPopup!");
    ShowUIPanel(GuildMailerNewListPopup);
    GuildMailerNewListPopupEditBox:SetFocus();
end


-----------------------------------------------------------------------------------
--
-- Add a new mailing list name
--
-----------------------------------------------------------------------------------
function GuildMailer_AddNewMailingListName()
    HideUIPanel(GuildMailerNewListPopup);

    GuildMailerDebug("New Name = "..GuildMailerNewListPopupEditBox:GetText());
    GuildMailer_AddNewListNameToTable(GuildMailerNewListPopupEditBox:GetText());
    GuildMailerListMakerEditBox:SetText("");    
end



---------------------------------------------------------------------------------
--
-- Comparison subfunction for table.sort() on a mailing list
-- 
---------------------------------------------------------------------------------
function GuildMailer_CompareMailingLists(entry1, entry2)
    if (entry1.NAME < entry2.NAME) then
        return true;
    else
        return false;
    end
end

-----------------------------------------------------------------------------------
--
-- Add the new mailing list to the table of existing mailing lists
--
-----------------------------------------------------------------------------------
function GuildMailer_AddNewListNameToTable(theName)
    if (theName ~= "") then
        GuildMailerDebug("GuildMailer_AddNewListNameToTable: "..asText(GUILDMAILER_CONFIG));
        local tempTable = { };
        tempTable.NAME = theName;
        tempTable.RECIPIENTS = { };
        table.insert(GUILDMAILER_CONFIG.MAILINGLISTS, tempTable);
        table.sort(GUILDMAILER_CONFIG.MAILINGLISTS, GuildMailer_CompareMailingLists);
        GUILDMAILER_CONFIG.SELECTED_MAILINGLIST = theName;
        UIDropDownMenu_Initialize(GuildMailerListMakerFrameDropDown, GuildMailer_DropDown_Populate);
        UIErrorsFrame:AddMessage("Added New Mailing List: "..theName, 0.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
    end
end


-----------------------------------------------------------------------------------
--
-- Use the selected mailing list as a recipient for the email
--
-----------------------------------------------------------------------------------
function GuildMailer_UseMailingList()
    GuildMailer_StoreMailingListMembers();
    GuildMailerDebug("The List = ["..GuildMailerListMakerEditBox:GetText().."]");
    if (GUILDMAILER_CONFIG.SELECTED_MAILINGLIST ~= "") then
        SendMailNameEditBox:SetText(GUILDMAILER_CONFIG.SELECTED_MAILINGLIST);
        SendMailSubjectEditBox:SetFocus();
    else
        SendMailNameEditBox:SetFocus();
    end
end


---------------------------------------------------------------------------------
--
-- Hook us onto the original sendmail() function
-- 
---------------------------------------------------------------------------------
function GuildMailer_HookSendMail(toggle)

    if (toggle) then
        GuildMailer_SendMail_Orig = SendMailFrame_SendMail;
        SendMailFrame_SendMail = GuildMailer_SendMail;
    else
        SendMailFrame_SendMail = GuildMailer_SendMail_Orig;
        GuildMailer_SendMail_Orig = nil;
    end
    
end


-----------------------------------------------------------------------------------
--
-- Overloads the original SendMailFrame_SendMail() function
--
-----------------------------------------------------------------------------------
function GuildMailer_SendMail()

    GuildMailerDebug("in SendMail: "..asText(GUILDMAILER_CONFIG));
    mailingListIndex = GuildMailer_FindMailingListIndex(SendMailNameEditBox:GetText());
    if (mailingListIndex) then
        GuildMailerDebug("Found Mailing List = ["..GUILDMAILER_CONFIG.MAILINGLISTS[mailingListIndex].NAME.."]");
        GuildMailer_MailQueue = { };
        GuildMailer_MailQueue.Body = SendMailBodyEditBox:GetText();
        GuildMailer_MailQueue.Subject = SendMailSubjectEditBox:GetText();
        GuildMailer_MailQueue.Recipients = { };
        for i = 1, table.getn(GUILDMAILER_CONFIG.MAILINGLISTS[mailingListIndex].RECIPIENTS) do
            table.insert(GuildMailer_MailQueue.Recipients, GUILDMAILER_CONFIG.MAILINGLISTS[mailingListIndex].RECIPIENTS[i]);
        end
        GuildMailerDebug("GuildMailer_MailQueue = "..asText(GuildMailer_MailQueue));
        GuildMailer_MailQueueFrameCounter = 1;      
        GuildMailer_SendingMail = true;
        GuildMailer_ReadyToSendNextMessage = true;
        GuildMailer_TimeLastMailSent = GetTime();
        Print("GuildMailer: Sending message \""..GuildMailer_MailQueue.Subject.."\" to your mailing list \""..GUILDMAILER_CONFIG.MAILINGLISTS[mailingListIndex].NAME..".\"  Please don't close the mail interface until sending is complete.", 1.0, 1.0, 0.5);
    else
        GuildMailer_SendMail_Orig(SendMailNameEditBox:GetText(), SendMailSubjectEditBox:GetText(), SendMailBodyEditBox:GetText());
    end
end


-----------------------------------------------------------------------------------
--
-- Load the dropdown box of possible mailing list names
--
-----------------------------------------------------------------------------------
function GuildMailer_DropDown_OnLoad()
    GuildMailerDebug("On DropDown_OnLoad: "..asText(GUILDMAILER_CONFIG));
    UIDropDownMenu_Initialize(this, GuildMailer_DropDown_Populate);
    UIDropDownMenu_SetWidth(130);
end


-----------------------------------------------------------------------------------
--
-- Initialize the editbox that shows the recipients of the selected mailing list
--
-----------------------------------------------------------------------------------
function GuildMailer_ListMakerEditBox_Init()
    if (GUILDMAILER_CONFIG.SELECTED_MAILINGLIST == "") then
        GuildMailerListMakerEditBox:SetText("");
    else
        GuildMailerListMakerEditBox:SetText(GuildMailer_MailingListNamesToCommaSeparatedString(GUILDMAILER_CONFIG.SELECTED_MAILINGLIST));
    end
end


-----------------------------------------------------------------------------------
--
-- Fill the drop down box with all the possible mailing list names
--
-----------------------------------------------------------------------------------
function GuildMailer_DropDown_Populate()
    local info;
    GuildMailerDebug("On DropDown_Populate: "..asText(GUILDMAILER_CONFIG));
 
    for listNum = 1, table.getn(GUILDMAILER_CONFIG.MAILINGLISTS) do
    info = {};
    info.text = GUILDMAILER_CONFIG.MAILINGLISTS[listNum].NAME;
    info.func = GuildMailer_DropDown_OnClick;
    info.value = GUILDMAILER_CONFIG.MAILINGLISTS[listNum].NAME;
    UIDropDownMenu_AddButton(info);
    end
    UIDropDownMenu_SetSelectedValue(GuildMailerListMakerFrameDropDown, GUILDMAILER_CONFIG.SELECTED_MAILINGLIST);
    UIDropDownMenu_SetText(GUILDMAILER_CONFIG.SELECTED_MAILINGLIST, GuildMailerListMakerFrameDropDown);
end


-----------------------------------------------------------------------------------
--
-- Select an item from the dropdown box of possible mailing list names
--
-----------------------------------------------------------------------------------
function GuildMailer_DropDown_OnClick()
    UIDropDownMenu_SetSelectedValue(GuildMailerListMakerFrameDropDown, this.value);
    local mailingListName = UIDropDownMenu_GetSelectedValue(GuildMailerListMakerFrameDropDown);
    GuildMailerListMakerEditBox:SetText(GuildMailer_MailingListNamesToCommaSeparatedString(mailingListName));
    GuildMailerDebug("GuildMailer_DropDown_OnClick = "..mailingListName);
    GUILDMAILER_CONFIG.SELECTED_MAILINGLIST = mailingListName;
    GuildMailerDebug("GuildMailer_DropDown_OnClick: "..asText(GUILDMAILER_CONFIG));
end


-----------------------------------------------------------------------------------
--
-- When the user clicks on the ADD button, store the names in the mailing list
--
-----------------------------------------------------------------------------------
function GuildMailer_StoreMailingListMembers()
    if (table.getn(GUILDMAILER_CONFIG.MAILINGLISTS) > 0) then
        rawList = GuildMailerListMakerEditBox:GetText();
        mailingListIndex = GuildMailer_FindMailingListIndex(GUILDMAILER_CONFIG.SELECTED_MAILINGLIST);
        GUILDMAILER_CONFIG.MAILINGLISTS[mailingListIndex].RECIPIENTS = GuildMailer_CommaSeparatedStringToTableEntries(rawList);
        GuildMailerDebug("After StoreMailingListMembers: "..asText(GUILDMAILER_CONFIG));
    end
end



-----------------------------------------------------------------------------------
--
-- When the user clicks on the DELETE LIST button, remove this mailing list
--
-----------------------------------------------------------------------------------
function GuildMailer_DeleteMailingList()
    local deletedListName = GUILDMAILER_CONFIG.SELECTED_MAILINGLIST;
    mailingListIndex = GuildMailer_FindMailingListIndex(GUILDMAILER_CONFIG.SELECTED_MAILINGLIST);
    if (mailingListIndex) then
        table.remove(GUILDMAILER_CONFIG.MAILINGLISTS, mailingListIndex);
        if (table.getn(GUILDMAILER_CONFIG.MAILINGLISTS) > 0) then
            GUILDMAILER_CONFIG.SELECTED_MAILINGLIST = GUILDMAILER_CONFIG.MAILINGLISTS[1].NAME;
        else
            GUILDMAILER_CONFIG.SELECTED_MAILINGLIST = "";
        end
        GuildMailer_DropDown_Populate();
        UIErrorsFrame:AddMessage("Mailing List "..deletedListName.." Deleted!", 1.0, 0.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
        GuildMailer_ListMakerEditBox_Init();
    end
    GuildMailerDebug("After DeleteMailingList: "..asText(GUILDMAILER_CONFIG));
end



-----------------------------------------------------------------------------------
--
-- Given a string of comma separated values, return a table with an entry for each value
--
-----------------------------------------------------------------------------------
function GuildMailer_CommaSeparatedStringToTableEntries(theString)

    resultTable = { };
    for theEntry in string.gfind(theString, "%a+") do
        table.insert(resultTable, theEntry);
    end
    
    return resultTable;
end


-----------------------------------------------------------------------------------
--
-- Build the comma separated string of recipients for the specified mailing list
--
-----------------------------------------------------------------------------------
function GuildMailer_MailingListNamesToCommaSeparatedString(theListName)
    recipientListString = "";
    
    listNumber = GuildMailer_FindMailingListIndex(theListName);
    
    if (listNumber) then
        for i = 1, table.getn(GUILDMAILER_CONFIG.MAILINGLISTS[listNumber].RECIPIENTS) do
            recipientListString = recipientListString..GUILDMAILER_CONFIG.MAILINGLISTS[listNumber].RECIPIENTS[i];
            if (i ~= table.getn(GUILDMAILER_CONFIG.MAILINGLISTS[listNumber].RECIPIENTS)) then
                recipientListString = recipientListString..", ";
            end
        end
    end
    
    return recipientListString;
end



-----------------------------------------------------------------------------------
--
-- Given the name of a mailing list, return its index in the mailing list table
--
-----------------------------------------------------------------------------------
function GuildMailer_FindMailingListIndex(theListName)
    for i = 1, table.getn(GUILDMAILER_CONFIG.MAILINGLISTS) do
        listNumber = i;
        if (GUILDMAILER_CONFIG.MAILINGLISTS[i].NAME == theListName) then 
            return listNumber;
        end
    end

    return nil;
end



-----------------------------------------------------------------------------------
--
-- This function imports all your guildmembers into the current list
--
-----------------------------------------------------------------------------------
function GuildMailer_ImportGuildMembers()
	
	--GuildMailer_OpenGuildRoster();
 
   local MemberCount = GetNumGuildMembers();
   local GuildList ="";

	for i=1, MemberCount, 1 do
		local MemberName, MemberRank, MemberRankIndex, MemberLevel, MemberClass, MemberZone, MemberGroup, MemberNote, MemberOfficerNote, MemberIsOnline = GetGuildRosterInfo(i);
	
		if (UnitName("player") ~= MemberName) then
			GuildList = GuildList..MemberName..", ";
		end
	
	end
	
	
	GuildMailerListMakerEditBox:SetText(GuildList);
	GuildMailerDebug("Imported guild: "..GuildList);
  	--GuildMailer_CloseGuildRoster();
    return nil;
end


-----------------------------------------------------------------------------------
--
-- This function opens guild roster so you can import members
-- Obtained from http://www.cosmosui.org/forums/viewtopic.php?t=5525
--
-----------------------------------------------------------------------------------
function GuildMailer_OpenGuildRoster()
  previousSelectedTab = FriendsFrame.selectedTab;
  FriendsFrame.selectedTab = GUILDTAB_ID;
 
  previousFriendsFrameVisible = FriendsFrame:IsVisible();
  FriendsFrame:Show();
 
  previousShowOffline = GetGuildRosterShowOffline();
  SetGuildRosterShowOffline(GUILDTAB_SHOWOFFLINE);
end


-----------------------------------------------------------------------------------
--
-- This function closes the guild roster
-- Obtained from http://www.cosmosui.org/forums/viewtopic.php?t=5525
--
-----------------------------------------------------------------------------------

function GuildMailer_CloseGuildRoster()
  SetGuildRosterShowOffline(previousShowOffline);
  FriendsFrame.selectedTab = previousSelectedTab;
  if (previousFriendsFrameVisible) then
    FriendsFrame:Show();
  else
    FriendsFrame:Hide();
  end
end


---------------------------------------------------------------------------------
--
-- Show the tooltip text
-- 
---------------------------------------------------------------------------------
function GuildMailer_ShowTooltip(theText1, theText2, theText3, theText4, theText5)

    -- Set the anchor and text for the tooltip.
    GuildMailer_MoneyToggle();
    GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
    GuildMailer_MoneyToggle();

    GuildMailer_MoneyToggle();
    GameTooltip:SetText(theText1);
    GuildMailer_MoneyToggle();
    
    -- add description lines to the tooltip
    if (theText2) then
        GuildMailer_MoneyToggle();
        GameTooltip:AddLine(theText2);
        GuildMailer_MoneyToggle();
    end
    if (theText3) then
        GuildMailer_MoneyToggle();
        GameTooltip:AddLine(theText3);
        GuildMailer_MoneyToggle();
    end
    if (theText4) then
        GuildMailer_MoneyToggle();
        GameTooltip:AddLine(theText4);
        GuildMailer_MoneyToggle();
    end
    if (theText5) then
        GuildMailer_MoneyToggle();
        GameTooltip:AddLine(theText5);
        GuildMailer_MoneyToggle();
    end
    
    -- Adjust width and height to account for new lines and show the tooltip
    -- (the Show() command automatically adjusts the width/height)
    GameTooltip:Show();

end



-----------------------------------------------------------------------------------
--
-- Toggle Debugging
--
-----------------------------------------------------------------------------------
function GuildMailer_ToggleDebug()
    GUILDMAILER_DEBUG = (not GUILDMAILER_DEBUG);
    if (GUILDMAILER_DEBUG) then
        Print("GuildMailer: Debug On");
    else
        Print("GuildMailer: Debug Off");
    end
end



-----------------------------------------------------------------------------------
--
-- Toggle the AddOn on/off
--
-----------------------------------------------------------------------------------
function GuildMailer_Toggle(toggle)
    if (toggle) then
        GUILDMAILER_CONFIG.ENABLED = true;
    else
        GUILDMAILER_CONFIG.ENABLED = false;
    end
end


-----------------------------------------------------------------------------------
--
-- Debug Printout Function
--
-----------------------------------------------------------------------------------
function GuildMailerDebug(theText)
    if (GUILDMAILER_DEBUG) then
        Print("GuildMailer: "..theText, 1.0, 1.0, 0.5);
    end
end






-----------------------------------------------------------------------------------
--
-- Shopping Function
--
-----------------------------------------------------------------------------------



local unit_name = 0;
local list = {};
local makercount;
local sent = 0;


function Shopping_OnLoad()
	HideUIPanel(Shopping_Frame);
	if(GUILDMAILER_CONFIG.ENABLED == true) then
		StaticPopupDialogs["SHOPPING"] = {
  		text = SHOPPING_POPUP_SHOPPING_TEXT,
  		button1 = "OK",
  		OnAccept = function()
      		showChatMsg(SHOPPING_POPUP_SHOPPING_MESSAGE1, 1.0, 1.0, 0.0, 1.0);
	  		orderwaiting = 1;
	  		Shopping_Frame:Hide();
  		end,
  		timeout = 0,
  		whileDead = 0,
  		hideOnEscape = 0
		};
	
		StaticPopupDialogs["OPENINBOX"] = {
  		text = SHOPPING_POPUP_OPENINBOX_TEXT,
  		button1 = SHOPPING_POPUP_OPENINBOX_BUTTON1,
		OnAccept = function() 
	  		HideUIPanel(Shopping_Frame);
	  		basketempty = 0;
	  		sendShoppingCart();
		end,
  		button2 = SHOPPING_POPUP_OPENINBOX_BUTTON2,
		OnCancel = function (_,reason)
      		if reason == "timeout" or reason == "clicked" then
          		ShowUIPanel(Shopping_Frame);
      		else
      	end
  		end, 
		timeout = 0,
  		whileDead = 0,
  		hideOnEscape = 0
		};
	
	checkFile();
	else
		showChatMsg(SHOPPING_ADDON_DISABLED_TEXT);
	end
end

function msgprint(text)
	if(text~=nil) then
		my_msgFrame:AddMessage(text);
	end
end

function checkFile()
	if(shoppinglist~=nil and table.getn(shoppinglist) >0) then
		makercount = table.getn(shoppinglist);
		order = 0;
		for i=1, makercount, 1 do
			if (shoppinglist[i][4] == UnitName("player") and shoppinglist[i][6] == "outbox") then
				order = 1;
			end
		end
		if(order ==1) then
			fillTable();
			empty=0;
			basketempty = 0;
			StaticPopup_Show ("OPENINBOX");
		end
	end
	if(shoppinglist==nil) then
		Shopping_Frame:Hide();
	end
end

function fillTable()
	makercount = table.getn(shoppinglist);
	count = 0;
	for i=1, makercount, 1 do
		if (shoppinglist[i][4] == UnitName("player") and shoppinglist[i][6] == "outbox") then --check if the requester is the logged in player (requestername=playername) leave this if clause to show all orders
			--Print("Anzeigen ? (shoppinglist[6] = outbox?): "..shoppinglist[i][6]);
			menge_Frame:AddMessage(shoppinglist[i][2]);
			produkt_Frame:AddMessage(shoppinglist[i][3]);
			sendenan_Frame:AddMessage(shoppinglist[i][4]);
			count = count+1; --Increase counter needed for checkbox state see setCheckButtonState(count) function
			table.insert(list,i); --Test um die Reihenfolge der Liste zu speichern....
			--acceptorder_Frame_5:Hide();
			--acceptorder_Frame_[i]:SetChecked(true);
		end
	end
	setCheckButtonState(count);
end

function checkOrders()
	if(shoppinglist~=nil and table.getn(shoppinglist) >0) then
		makercount = table.getn(shoppinglist);
		count = 0;
		for i=1, makercount, 1 do
			if (shoppinglist[i][4] == UnitName("player") and shoppinglist[i][6] == "outbox") then --check if the requester is the logged in player (requestername=playername) leave this if clause to show all orders
				alert = 1;
			end
		end
	end
	if(shoppinglist==nil) then
		Shopping_Frame:Hide();
	end
end

function setCheckButtonState(count)
	if(count == 0) then
		acceptorder_Frame_1:Hide();
		acceptorder_Frame_2:Hide();
		acceptorder_Frame_3:Hide();
		acceptorder_Frame_4:Hide();
		acceptorder_Frame_5:Hide();
		acceptorder_Frame_6:Hide();
		acceptorder_Frame_7:Hide();
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 1) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:Hide();
		acceptorder_Frame_3:Hide();
		acceptorder_Frame_4:Hide();
		acceptorder_Frame_5:Hide();
		acceptorder_Frame_6:Hide();
		acceptorder_Frame_7:Hide();
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 2) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:Hide();
		acceptorder_Frame_4:Hide();
		acceptorder_Frame_5:Hide();
		acceptorder_Frame_6:Hide();
		acceptorder_Frame_7:Hide();
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 3) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:Hide();
		acceptorder_Frame_5:Hide();
		acceptorder_Frame_6:Hide();
		acceptorder_Frame_7:Hide();
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 4) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:Hide();
		acceptorder_Frame_6:Hide();
		acceptorder_Frame_7:Hide();
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 5) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:Hide();
		acceptorder_Frame_7:Hide();
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 6) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:Hide();
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 7) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:Hide();
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 8) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:Hide();
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 9) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:SetChecked(true);
		acceptorder_Frame_10:Hide();
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 10) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:SetChecked(true);
		acceptorder_Frame_10:SetChecked(true);
		acceptorder_Frame_11:Hide();
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 11) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:SetChecked(true);
		acceptorder_Frame_10:SetChecked(true);
		acceptorder_Frame_11:SetChecked(true);
		acceptorder_Frame_12:Hide();
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 12) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:SetChecked(true);
		acceptorder_Frame_10:SetChecked(true);
		acceptorder_Frame_11:SetChecked(true);
		acceptorder_Frame_12:SetChecked(true);
		acceptorder_Frame_13:Hide();
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 13) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:SetChecked(true);
		acceptorder_Frame_10:SetChecked(true);
		acceptorder_Frame_11:SetChecked(true);
		acceptorder_Frame_12:SetChecked(true);
		acceptorder_Frame_13:SetChecked(true);
		acceptorder_Frame_14:Hide();
		acceptorder_Frame_15:Hide();
	end
	if(count == 14) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:SetChecked(true);
		acceptorder_Frame_10:SetChecked(true);
		acceptorder_Frame_11:SetChecked(true);
		acceptorder_Frame_12:SetChecked(true);
		acceptorder_Frame_13:SetChecked(true);
		acceptorder_Frame_14:SetChecked(true);
		acceptorder_Frame_15:Hide();
	end
	if(count == 15) then
		acceptorder_Frame_1:SetChecked(true);
		acceptorder_Frame_2:SetChecked(true);
		acceptorder_Frame_3:SetChecked(true);
		acceptorder_Frame_4:SetChecked(true);
		acceptorder_Frame_5:SetChecked(true);
		acceptorder_Frame_6:SetChecked(true);
		acceptorder_Frame_7:SetChecked(true);
		acceptorder_Frame_8:SetChecked(true);
		acceptorder_Frame_9:SetChecked(true);
		acceptorder_Frame_10:SetChecked(true);
		acceptorder_Frame_11:SetChecked(true);
		acceptorder_Frame_12:SetChecked(true);
		acceptorder_Frame_13:SetChecked(true);
		acceptorder_Frame_14:SetChecked(true);
		acceptorder_Frame_15:SetChecked(true);
	end
end

	
function showChatMsg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function showTableList()
	ShowUIPanel(Shopping_Frame);
end

function sendShoppingCart()
	if (orderwaiting == 1) then
		orderwaiting = 0;
	end
	GuildMailer_SendingMail = 1;
	local date = date();
	if(mailboxopen == 1 and basketempty == 0) then
        GuildMailer_MailQueue = { };
		GuildMailer_MailQueue.Body = { };
		GuildMailer_MailQueue.Recipients = { };
        makercount = table.getn(shoppinglist);
		for i=1, makercount, 1 do
			if (shoppinglist[i][4] == UnitName("player") and shoppinglist[i][6] ~= "deleted" and shoppinglist[i][6] ~= "send") then
				--Print("Mail an: "..shoppinglist[i][4]); --For Debugging :)
				table.insert(GuildMailer_MailQueue.Body, shoppinglist[i][2].." x  "..shoppinglist[i][3].."\n\n"..SHOPPING_SENDCART_MESSAGE2.."\n"..shoppinglist[i][4].."\n\n"..SHOPPING_SENDCART_MESSAGE3);
	       		GuildMailer_MailQueue.Subject = SHOPPING_SENDCART_MESSAGE4..date;
        		table.insert(GuildMailer_MailQueue.Recipients, shoppinglist[i][1]);
				shoppinglist[i][6] = "send";
			end
        end
		GuildMailerDebug("GuildMailer_MailQueue = "..asText(GuildMailer_MailQueue));
        GuildMailer_MailQueueFrameCounter = 1;      
        GuildMailer_SendingMail = true;
	    GuildMailer_ReadyToSendNextMessage = true;
        GuildMailer_TimeLastMailSent = GetTime();
        Print(SHOPPING_SENDCART_MESSAGE1, 1.0, 0, 0);
		Shopping_SendNextMessage();
		menge_Frame:Clear();
		produkt_Frame:Clear();
		sendenan_Frame:Clear();
	else
		StaticPopup_Show ("SHOPPING");
		Shopping_Frame_ok:Disable();
		Shopping_Frame_cancel:Disable();
	end
	

end


function Shopping_SendNextMessage()
	--Print("Mail an: "..GuildMailer_LastAttempedRecipient); --For Debugging :)
	GuildMailer_ReadyToSendNextMessage = false;
    GuildMailer_LastAttempedRecipient = GuildMailer_MailQueue.Recipients[1];
	Shopping_LastBody = GuildMailer_MailQueue.Body[1];
    table.remove(GuildMailer_MailQueue.Recipients, 1);
	table.remove(GuildMailer_MailQueue.Body, 1);
	--Print("Mail an: "..GuildMailer_LastAttempedRecipient); --For Debugging :)
	--Print("Subject: "..GuildMailer_MailQueue.Subject); --For Debugging :)
	--Print("Last Body :"..Shopping_LastBody); --For Debugging :)
    SendMail(GuildMailer_LastAttempedRecipient, GuildMailer_MailQueue.Subject, Shopping_LastBody);
	--printState();
end

function changeOrderState(number) --Hier muss noch eine berprfung der Tabelle gemacht werden soll heien an welcher Stell muss der Statsu gendert werden....
	--counter = table.getn(list);
	--Print("Counter :"..counter);
	--for i=1, counter, 1 do
	--	Print("Line "..i..": "..list[i]);
	--end
	entry=list[number];
	--Print("number: "..number);
	--Print("Entry state before send: "..shoppinglist[entry][6]);
	
	if (number ==1) then
		if (acceptorder_Frame_1:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==2) then
		if (acceptorder_Frame_2:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==3) then
		if (acceptorder_Frame_3:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==4) then
		if (acceptorder_Frame_4:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==5) then
		if (acceptorder_Frame_5:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==6) then
		if (acceptorder_Frame_6:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==7) then
		if (acceptorder_Frame_7:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==8) then
		if (acceptorder_Frame_8:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==9) then
		if (acceptorder_Frame_9:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==10) then
		if (acceptorder_Frame_10:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==11) then
		if (acceptorder_Frame_11:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==12) then
		if (acceptorder_Frame_12:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==13) then
		if (acceptorder_Frame_13:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==14) then
		if (acceptorder_Frame_14:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
	if (number ==15) then
		if (acceptorder_Frame_15:GetChecked() == nil) then
			shoppinglist[entry][6] = "deleted";
		--else
		--	shoppinglist[entry][6] = "send";
		end
	end
end

function printState() --for Debugging purposes
	counter = table.getn(list);
	--Print("Counter :"..counter);
	for i=1, counter, 1 do
		Print("Line "..i..": "..list[i]);
		entry = list[i];
		Print("Entry "..list[i].." state after send: "..shoppinglist[entry][6]);
	end
end

function checkFadeState()
	if (UIFrameIsFading(ShoppingToggleButton)) then
		UIFrameFlashRemoveFrame(ShoppingToggleButton);
	end
end
